/** @file sys_main.c 
*   @brief Application main file
*   @date 25.April.2014
*   @version 03.09.00
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* (c) Texas Instruments 2009-2014, All rights reserved. */

/* USER CODE BEGIN (0) */
/* USER CODE END */

/* Include Files */

#include "sys_common.h"

/* USER CODE BEGIN (1) */
#include "i2c.h"
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
#define 	RTC_address		0x68

uint8 RTC_read(uint8 sub_add);
void RTC_write(uint8 sub_add, uint8 data);
/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
	uint8 rdata;
	int i;

	i2cInit();
	i2cSetBaudrate(i2cREG1, 100);	// 100kHz
	i2cSetMode(i2cREG1, I2C_MASTER);

	while(1)
	{
		rdata = RTC_read(0x09);
		RTC_write(0x09,((rdata & 0xF0)|0x05|(1<<6)));
		rdata = RTC_read(0x09);
		RTC_write(0x09,(0xAA));
		rdata = RTC_read(0x09);

		for(i=0;i<10000;i++);
	}
/* USER CODE END */
}

/* USER CODE BEGIN (4) */
uint8 RTC_read(uint8 sub_add)
{
	uint8 t_data;
	// -------------------------------------
	// Send Sub Address to RTC
	// -------------------------------------
	i2cREG1->MDR |= (uint32)(1 << 9 | 1 << 10);		// send & master
	i2cREG1->MDR &= ~(uint32)(1 << 15);				// ACK
	i2cSetStart(i2cREG1);
	i2cSetStop(i2cREG1);
	i2cSetCount(i2cREG1, 1);
	i2cSetSlaveAdd(i2cREG1, RTC_address);
	i2cSendByte(i2cREG1, sub_add);

	// -------------------------------------
	// Wait for send ending
	// -------------------------------------
	while(!i2cIsTxReady(i2cREG1));

	// -------------------------------------
	// Read data from RTC
	// -------------------------------------
	i2cREG1->MDR &= ~(uint32)(1 << 9);				// receive
	i2cREG1->MDR |= (uint32)(1 << 15);				// NACK
	i2cSetStart(i2cREG1);
	i2cSetStop(i2cREG1);
	i2cSetCount(i2cREG1, 1);
	i2cSetSlaveAdd(i2cREG1, RTC_address);
	t_data = i2cReceiveByte(i2cREG1);

	i2cClearSCD(i2cREG1);

	return t_data;
}

void RTC_write(uint8 sub_add, uint8 data)
{
	// -------------------------------------
	// Send Sub Address to RTC
	// -------------------------------------
	i2cREG1->MDR |= (uint32)(1 << 9 | 1 << 10);		// send & master
	i2cREG1->MDR &= ~(uint32)(1 << 15);				// ACK
	i2cSetStart(i2cREG1);
	i2cSetStop(i2cREG1);
	i2cSetCount(i2cREG1, 2);						// send two bytes
	i2cSetSlaveAdd(i2cREG1, RTC_address);
	i2cSendByte(i2cREG1, sub_add);
	i2cSendByte(i2cREG1, data);
	// -------------------------------------
	// Wait for send ending
	// -------------------------------------
	while(!i2cIsTxReady(i2cREG1));

	i2cClearSCD(i2cREG1);
}
/* USER CODE END */
